Name: u-boot-sunxi-riscv
Version: 2024.01
Release: alt4.git8c36243b6c

Summary: Das U-Boot
License: GPLv2+
Group: System/Kernel and hardware
Url: https://www.denx.de/wiki/U-Boot

ExclusiveArch: riscv64
BuildArch: noarch

Source: %name-%version-%release.tar

BuildRequires: ccache
BuildRequires: bc dtc >= 1.4 flex libssl-devel
BuildRequires: python3(pkg_resources) python3(libfdt)

# Forbid silent rebuilds with newer OpenSBI
BuildRequires: opensbi = 1.4-alt1


%description
boot loader for embedded boards based on PowerPC, ARM, MIPS and several
other processors, which can be installed in a boot ROM and used to
initialize and test the hardware or to download and run application code.
This package supports boards based on RISC-V SoCs.

%prep
%setup

%build
mkdir out
OPENSBI=%_datadir/opensbi/generic/firmware/fw_dynamic.bin
for board in lichee_rv lichee_rv_dock lichee_rv_86_panel mangopi_mq_pro nezha; do
    mkdir build
    %make_build \
        HOSTCC="ccache gcc" \
        CC="ccache ${CROSS_COMPILE:-}gcc" \
        DTC="$(which dtc)" \
        EXTRAVERSION="-sunxi-riscv-%release" \
        V=1 O=build OPENSBI="$OPENSBI" ${board}_defconfig all
    mkdir out/${board}
    cp -t out/${board} build/u-boot-sunxi-with-spl.bin
    rm -rf build
done

%install
mkdir -p %buildroot%_datadir
cp -a out %buildroot%_datadir/u-boot

%files
%doc README
%_datadir/u-boot/*

%changelog
* Mon Feb 19 2024 Ivan A. Melnikov <iv@altlinux.org> 2024.01-alt4.git8c36243b6c
- Set buildarch to noarch to ease usage on any system.

* Tue Jan 30 2024 Ivan A. Melnikov <iv@altlinux.org> 2024.01-alt3.git8c36243b6c
- Pass correct RAM size to kernel via FDT.

* Tue Jan 30 2024 Ivan A. Melnikov <iv@altlinux.org> 2024.01-alt2.git8c36243b6c
- BREAKING: Expect device tree files in allwinner subdirectory
  to match the upstream kernel.

* Thu Dec 28 2023 Ivan A. Melnikov <iv@altlinux.org> 2024.01-alt1.git70592dbc
- Update to the latest snapshot.
- Fix extlinux boot by using correct addresses in environment
  configuration.
- More Lichee RV variants.

* Thu Feb 03 2022 Dmitry Terekhin <jqt4@altlinux.org> 2022.01-alt2
- Rename package.
- Make sun20i_d1_spl in a separate package.
- Add ability to boot Lichee RV board from USB.
- Set default fdtfile names as in Alt.
- Load FDT from any partition on boot device.

* Fri Jan 14 2022 Sergey Bolshakov <sbolshakov@altlinux.ru> 2022.01-alt1
- initial
